#include <RespJson.h>

bool RespJson::RespManage(char* str, string jsonStr)
{
    Json::Reader reader;
    Json::Value root;
    string serviceId;
    if (reader.parse(str, root))
    {
        serviceId = root["serviceId"].asString();
    }
    if(serviceId == "platformupgradeDevices" || serviceId == "platformLsuueConfigureFile" || serviceId == "getDeviceLogFile"
        || serviceId == "getDeviceData" || serviceId == "setDeviceTime" || serviceId == "setTransOnlineMonitConfig"
        || serviceId == "setFunctionConfiguration" || serviceId == "setIcingOnlineAlarmMonitConfig" || serviceId == "setPhotoParams"
        || serviceId == "SetAcceptCameraPhoto" || serviceId == "setCaptureTimesTaskParameter" || serviceId == "actionRestart"
        || serviceId == "cameraRemoteControl" || serviceId == "manualCapturePicture" || serviceId == "setMicroMeteorologicalAlarm")
    {
        jsonStr = CommonResp(str);
    }else if(serviceId == "getDeviceLogList")
    {
//        getDeviceLogListResp
    }
//    else if...
}

string RespJson::CommonResp(char* str)
{
    Json::Reader reader;
    Json::Value root;
    int mid;
    if (reader.parse(str, root))
    {
        mid = root["mid"].asInt();
    }
    string jsonStr;
    CommonJSON(jsonStr, 0, 0, mid);
    return jsonStr;
}

bool RespJson::CommonJSON(string jsonStr, int resultCode, int errcode, int mid)
{
    /*通用响应JSON*/
    Json::Value root;
        Json::Value body;
        body["resultCode"] = resultCode;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getDeviceLogListJSON(string jsonStr,DeviceLogList_JSON bodyData, int errcode, int mid)
{
    /*查询终端设备日志列表*/
    Json::Value root;
        Json::Value body;
        body["resultCode"] = bodyData.resultCode;
        body["fileCount"] = bodyData.fileCount;
            Json::Value List;
            for(int i = 0; i < bodyData.fileCount; i++)
            {
                Json::Value ListData;
                ListData["fileType"] = bodyData.fileList[i].fileType;
                ListData["fileName"] = bodyData.fileList[i].fileName;
                ListData["time"] = static_cast<Json::Int64>(bodyData.fileList[i].time);
                ListData["fileSize"] = bodyData.fileList[i].fileSize;
                List.append(ListData);
            }
        body["fileList"] = List;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getDeviceTimeJSON(string jsonStr,DeviceTime_JSON bodyData, int errcode, int mid)
{
    /*平台端查询终端设备的系统时间*/
    Json::Value root;
        Json::Value body;
        body["timingType"] = bodyData.timingType;
        body["currentTime"] = static_cast<Json::Int64>(bodyData.currentTime);
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getTransOnlineMonitConfigJSON(string jsonStr,TransOnlineMonitConfig_JSON bodyData, int errcode, int mid)
{
    /*获取输电在线监测终端的运行状态参数*/
    Json::Value root;
        Json::Value body;
        body["heartbeatInterval"] = bodyData.heartbeatInterval;
        body["sampleInterval"] = bodyData.sampleInterval;
        body["sleepDuration"] = bodyData.sleepDuration;
        body["onlineInterval"] = bodyData.onlineInterval;
            Json::Value List;
            for(int i = 0; i < 29; i++)
            {
                Json::Value ListData;
                ListData["day"] = bodyData.restartTime[i].day;
                ListData["hour"] = bodyData.restartTime[i].hour;
                ListData["minute"] = bodyData.restartTime[i].minute;
                List.append(ListData);
            }
        body["restartTime"] = List;
        body["ipAddr"] = bodyData.ipAddr;
        body["port"] = bodyData.port;
        body["httpIp"] = bodyData.httpIp;
        body["httpPort"] = bodyData.httpPort;
        body["PwrMode"] = bodyData.PwrMode;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getFunctionConfigurationJSON(string jsonStr,FunctionConfiguration_JSON bodyData, int errcode, int mid)
{
    /*获取装置功能配置*/
    Json::Value root;
        Json::Value body;
        Json::Value List;
            Json::Value ListData;
            ListData["function"] = bodyData.function;
            ListData["mode"] = bodyData.mode;
            List.append(ListData);
        body["configure"] = List;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getIcingOnlineAlarmMonitConfigJSON(string jsonStr,IcingOnlineAlarmMonitConfig_JSON bodyData, int errcode, int mid)
{
    /*获取设置覆冰在线监测终端的告警阈*/
    Json::Value root;
        Json::Value body;
        body["resultCode"] = bodyData.resultCode;
        body["fileCount"] = bodyData.interval;
        body["PullAAlarmThreshold"] = bodyData.PullAAlarmThreshold;
        body["windAlarmThreshold"] = bodyData.windAlarmThreshold;
        body["rainAlarmThreshold"] = bodyData.rainAlarmThreshold;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getPhotoParamsJSON(string jsonStr,PhotoParams_JSON bodyData, int errcode, int mid)
{
    /*平台端查询终端设备图片配置信息*/
    Json::Value root;
        Json::Value body;
        body["channel"] = bodyData.channel;
        body["color"] = bodyData.color;
        body["brightness"] = bodyData.brightness;
        body["contrast"] = bodyData.contrast;
        body["saturation"] = bodyData.saturation;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getCaptureTimesTaskInformationJSON(string jsonStr,CaptureTimesTask_JSON bodyData, int errcode, int mid)
{
    /*平台端查询终端设备定时抓拍任务信息*/
    Json::Value root;
        Json::Value body;
        body["channel"] = bodyData.channel;
        body["color"] = bodyData.groupNumber;
            Json::Value array;
        body["paramArray"] = array;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getDeviceSolarPowerPropertiesJSON(string jsonStr,DeviceSolarPower_JSON bodyData, int errcode, int mid)
{
    /*查询设备太阳能电池板状态数据*/
    Json::Value root;
        Json::Value body;
        body["batteryNumber"] = bodyData.batteryNumber;
        body["time"] = static_cast<Json::Int64>(bodyData.time);
        body["solarPanelVoltage"] = bodyData.solarPanelVoltage;
        body["solarPanelCurrent"] = bodyData.solarPanelCurrent;
        body["batteryVoltage"] = bodyData.batteryVoltage;
        body["batteryCurrent"] = bodyData.batteryCurrent;
        body["loadVoltage"] = bodyData.loadVoltage;
        body["loadCurrent"] = bodyData.loadCurrent;
        body["remainingBatteryPower"] = bodyData.remainingBatteryPower;
        body["batteryTemperature"] = bodyData.batteryTemperature;
        body["batteryChargeStatus"] = bodyData.batteryChargeStatus;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getWeatherMonitoringJSON(string jsonStr,Weather_JSON bodyData, int errcode, int mid)
{
    /*查询终端微气象数据*/
    Json::Value root;
    Json::Value body;
    body["resultCode"] = bodyData.resultCode;
    body["fileCount"] = bodyData.packageNum;
    Json::Value List;
    for(int i = 0; i < bodyData.packageNum; i++)
    {
        Json::Value ListData;
        ListData["time"] = static_cast<Json::Int64>(bodyData.fileList[i].time);
        ListData["Temperature"] = bodyData.fileList[i].Temperature;
        ListData["humidity"] = bodyData.fileList[i].humidity;
        ListData["airPressure"] = bodyData.fileList[i].airPressure;
        ListData["instanWindSpeed"] = bodyData.fileList[i].instanWindSpeed;
        ListData["aveWindSspeed1"] = bodyData.fileList[i].aveWindSspeed1;
        ListData["aveWindSspeed10"] = bodyData.fileList[i].aveWindSspeed10;
        ListData["maxWindSpeed10"] = bodyData.fileList[i].maxWindSpeed10;
        ListData["aveMaxWindSpeed10"] = bodyData.fileList[i].aveMaxWindSpeed10;
        ListData["extremeWindSpeed"] = bodyData.fileList[i].extremeWindSpeed;
        ListData["instanWindDirection"] = bodyData.fileList[i].instanWindDirection;
        ListData["aveWindDirection1"] = bodyData.fileList[i].aveWindDirection1;
        ListData["aveWindDirection10"] = bodyData.fileList[i].aveWindDirection10;
        ListData["extremeWindDirection"] = bodyData.fileList[i].extremeWindDirection;
        ListData["radiationIntensity"] = bodyData.fileList[i].radiationIntensity;
        ListData["precipitation1"] = bodyData.fileList[i].precipitation1;
        ListData["precipitation6"] = bodyData.fileList[i].precipitation6;
        ListData["precipitation12"] = bodyData.fileList[i].precipitation12;
        ListData["precipitation24"] = bodyData.fileList[i].precipitation24;
        List.append(ListData);
    }
    body["dataList"] = List;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getPullAndAngleMonitoringJSON(string jsonStr,PullAndAngle_JSON bodyData, int errcode, int mid)
{
    /*查询终端拉力倾角监测*/
    Json::Value root;
    Json::Value body;
    body["resultCode"] = bodyData.resultCode;
    body["type"] = bodyData.type;
    body["number"] = bodyData.number;
    Json::Value List;
    for(int i = 0; i < bodyData.number; i++)
    {
        Json::Value ListData;
        ListData["time"] = static_cast<Json::Int64>(bodyData.fileList[i].time);
        ListData["maxPull"] = bodyData.fileList[i].maxPull;
        ListData["fileName"] = bodyData.fileList[i].maxPullOblique;
        ListData["maxPullOblique"] = bodyData.fileList[i].maxPullWind;
        ListData["equalIceThickness"] = bodyData.fileList[i].equalIceThickness;
        List.append(ListData);
    }
    body["dataList"] = List;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}

bool RespJson::getMicroMeteorologicalAlarmJSON(string jsonStr,Alarm_JSON bodyData, int errcode, int mid)
{
    /*查询终端设备的微气象告警阈值*/
    Json::Value root;
    Json::Value body;
        body["level"] = bodyData.level;
        body["interval"] = bodyData.interval;
        body["windSpeedAlarm"] = bodyData.windSpeedAlarm;
        body["precipitationAlarm"] = bodyData.precipitationAlarm;
    root["body"] = body;
    root["errcode"] = errcode;
    root["mid"] = mid;
    root["msgType"] = "deviceRsp";

    Json::StyledWriter writer;
    jsonStr = writer.write(root);
    return true;
}
