#ifndef MQTT_CLIENT_ANDROID_RESPJSON_H
#define MQTT_CLIENT_ANDROID_RESPJSON_H
#include <json/json.h>
#include <string>

using namespace std;

typedef struct DeviceLogList_JSON
{
    int resultCode;
    int fileCount;
    struct file_List
    {
        int fileType;
        string fileName;
        time_t time;
        int fileSize;
    }fileList[1];
};

typedef struct DeviceTime_JSON
{
    int timingType;
    time_t currentTime;
};

typedef struct TransOnlineMonitConfig_JSON
{
    int heartbeatInterval;
    int sampleInterval;
    int sleepDuration;
    int onlineInterval;
    struct restart_Time
    {
        int day;
        int hour;
        int minute;
    }restartTime[29];
    string ipAddr;
    int port;
    string httpIp;
    int httpPort;
    int PwrMode;
};
typedef struct FunctionConfiguration_JSON
{
    string function;
    int mode;
};
typedef struct IcingOnlineAlarmMonitConfig_JSON
{
    int resultCode;
    int interval;
    float PullAAlarmThreshold;
    float windAlarmThreshold;
    float rainAlarmThreshold;
};
typedef struct PhotoParams_JSON
{
    int channel;
    int color;
    int brightness;
    int contrast;
    int saturation;
};
typedef struct CaptureTimesTask_JSON
{
    int channel;
    int groupNumber;
};
typedef struct DeviceSolarPower_JSON
{
    int batteryNumber;
    time_t time;
    float solarPanelVoltage;
    float solarPanelCurrent;
    float batteryVoltage;
    float batteryCurrent;
    float loadVoltage;
    float loadCurrent;
    int remainingBatteryPower;
    float batteryTemperature;
    int batteryChargeStatus;
};
typedef struct Weather_JSON
{
    int resultCode;
    int packageNum;
    struct file_List
    {
        time_t time;
        float Temperature;
        float humidity;
        float airPressure;
        float instanWindSpeed;
        float aveWindSspeed1;
        float aveWindSspeed10;
        float maxWindSpeed10;
        float aveMaxWindSpeed10;
        float extremeWindSpeed;
        float instanWindDirection;
        float aveWindDirection1;
        float aveWindDirection10;
        float extremeWindDirection;
        float radiationIntensity;
        float precipitation1;
        float precipitation6;
        float precipitation12;
        float precipitation24;
    }fileList[1];
};
typedef struct PullAndAngle_JSON
{
    int resultCode;
    int type;
    int number;
    struct file_List
    {
        time_t time;
        float maxPull;
        float maxPullOblique;
        float maxPullWind;
        float equalIceThickness;
    }fileList[1];
};
typedef struct Alarm_JSON
{
    int level;
    int interval;
    float windSpeedAlarm;
    float precipitationAlarm;
};

class RespJson {
    bool RespManage(char* str, string jsonStr);
    string CommonResp(char* str);


    bool CommonJSON(string jsonStr, int resultCode, int errcode, int mid);
    bool getDeviceLogListJSON(string jsonStr,DeviceLogList_JSON bodyData, int errcode, int mid);
    bool getDeviceTimeJSON(string jsonStr,DeviceTime_JSON bodyData, int errcode, int mid);
    bool getTransOnlineMonitConfigJSON(string jsonStr,TransOnlineMonitConfig_JSON bodyData, int errcode, int mid);
    bool getFunctionConfigurationJSON(string jsonStr,FunctionConfiguration_JSON bodyData, int errcode, int mid);
    bool getIcingOnlineAlarmMonitConfigJSON(string jsonStr,IcingOnlineAlarmMonitConfig_JSON bodyData, int errcode, int mid);
    bool getPhotoParamsJSON(string jsonStr,PhotoParams_JSON bodyData, int errcode, int mid);
    bool getCaptureTimesTaskInformationJSON(string jsonStr,CaptureTimesTask_JSON bodyData, int errcode, int mid);
    bool getDeviceSolarPowerPropertiesJSON(string jsonStr,DeviceSolarPower_JSON bodyData, int errcode, int mid);
    bool getWeatherMonitoringJSON(string jsonStr,Weather_JSON bodyData, int errcode, int mid);
    bool getPullAndAngleMonitoringJSON(string jsonStr,PullAndAngle_JSON bodyData, int errcode, int mid);
    bool getMicroMeteorologicalAlarmJSON(string jsonStr,Alarm_JSON bodyData, int errcode, int mid);
};

#endif //MQTT_CLIENT_ANDROID_RESPJSON_H
